; ==================================================================
; (c) ., 2009-2010
;    (6 )
; ==================================================================
;   :
; 
;
;      
;     :
; 1.    Play -    (512 ),     8    ,
;     1/128 .
; 2.     -       .  (50    ,   x5,8(116:20),
;    .. 580    ,      8.
;
;     -  24  :12 :16 = 125 .    2  4  PRS8.
;   "" A5 (:142) = 880,28  ( 880 ).
;
; <------------T  ---------->  <--T:2-->  <--T:4-->
;  :4    :4    :4    :4    :2
;  C0... C1... C2... C3... C4... C5...   C6..B7     C7..B8
;  . . . 127   254   508   1016..1923  2032..3846     []
;                    <---4  --->
;
;       SD  .
;      (    ).
;     -          set_track::  start::
;         -  .
; !   5 ( )   SD      SD!
; ==================================================================
;      :
; ==================================================================
;17 -   3
;18 -      
;19 -     ("" - "." - "." - "")
;   -    PLL (   )
;   - CPU 12   (    3 )
;   -    .
;   -        0 - !
;20 -   COM 
;21 - :  ,  32 
;22 - :  ,  32 ,      ,    440
;23 -    512       ( synth.asm).    .
;24 -     ( . );       
;   - !.   2-   (    1),  .
;   - !  PWM     synth_notes_off


include "m8c.inc"
include "PSoCAPI.inc"
include "Synth.inc"	; CMAX
include "SDCard.inc"


export _main
_main:

	;         PLL (  synth.asm)
;    or reg[CPU_SCR1],CPU_SCR1_ECO_ALLOWED	;   --     boot.tpl
	M8C_SetBank1
;;;;;;;;;;;;;;;;;;;;;;;;
	or reg[OSC_CR0],0x80	; ,    1 
	mov reg[ECO_TR],0x47	;   (0x77   )
;;;;;;;;;;;;;;;;;;;;;;;;
	M8C_SetBank0
	mov [startupcnt+0],0	; 512     .
	mov [startupcnt+1],0x01	;   1  (   )



	;    2  
	;    "Equal To"     :
	mov reg[PRS8_1_POLY_REG],0b00001000	;Polynomial Register
	mov reg[PRS8_1_SEED_REG],0b00000001	;Shift=Seed Register 
	call PRS8_1_Start
	;    :2  :4  OutputBitStream  CompareOut  PRS8
	;    OR ( XOR) --  Clk:2 

	; Port 0_0 ... 0_5      
	or  reg[PRT0GS],0b00111111 //lines 0..5 are connected to Global Bus. 
	//STRONG DRIVE 
    M8C_SetBank1
	and reg[PRT0DM2],~0b00111111
	or  reg[PRT0DM0], 0b00111111 
	and reg[PRT0DM1],~0b00111111
    M8C_SetBank0


	; ( )  
	mov A, 1
	call CMPPRG_1_Start
	mov A, RX8_1_PARITY_NONE
	call RX8_1_Start		;UART 9600,8,N,1 (   COM)
	call RX8_1_EnableInt	;  -    .   .   rx8_1int.asm
	call Counter8_1_Start
	call Counter8_2_Start
	call Counter8_3_Start
	call Counter8_4_Start
	call Counter8_5_Start
	call Counter8_6_Start
	;    
	or reg[INT_MSK0],0x40
	;   Column 0
	or reg[INT_MSK0],0x02

	;    
	mov [mask],0x08	; 
	mov [keys+0],0
	mov [keys+1],0
	mov [keycnt],0
	mov [mode],0	;       

;------------------------      -----------------------------
set_track::
	;   
	M8C_EnableGInt
	;   
	wait:	cmp [keycnt],CMAX	;    
			jc wait
	;  3        
	mov A,[keys+1]	;1- 
	and A,0x0F
	or  A,'0'
	mov [altName+0],A
	mov A,[keys+0]	;2- 
	asr A
	asr A
	asr A
	asr A
	and A,0x0F
	or  A,'0'
	mov [altName+1],A
	mov A,[keys+0]	;3- 
	and A,0x0F
	or  A,'0'
	mov [altName+2],A

;------------------------  ,   ---------------------------
start::
;	and [mode],~4	;  
;	or [mode],4	;  
	;  
	mov A,__ramareas_end	;Set top of stack to end of used RAM
	swap SP,A
	;   ,   
	call synth_init
	call synth_notes_off

	;   
	M8C_EnableGInt
	;  .   synth.asm
	;  .   rx8_1int.asm


;--------------------------    SD ----------------------------------
	call SDCard_Run	;     ,    

	; 
	cmp A,0
	jnz n1
	;toLCD_String 0,0,"OK!     "
	;    
	jmp wait_finish			;   	

n1:
	cmp A,1					;  "SD   "?
	jnz n2
;---------------------------------   FLASH ----------------------------------
	;"SD   "
	;toLCD_String 0,0,"noCard          "
	call synth_init
	;        (,    FLASH     9)
	mov A,[altName+2]		;  
	and A,0x0F				;  
	asl A					;x 2 (2   )
	mov X,A
	index track_table+1
	mov [adr1+0],A			; .  
	mov A,X
	index track_table+0
	mov [adr1+1],A			; .  

	;   ,    0 
main_ReadData_loop:
	mov X,[adr1+0]	;  
	mov A,[adr1+1]	;  
	romx			; 
	mov X,[ptrW]	; 
	mov [X],A
	jz wait_finish	; 0 - ,   ,    

	inc [adr1+0]	;  1 
	adc [adr1+1],0

	;increment ptrW pointer 
	add [ptrW],1
	cmp [ptrW],buff+BUFFERSIZE*BUFFNUMBER
	jc .skip_init
		sub [ptrW],BUFFERSIZE*BUFFNUMBER
	.skip_init:

	;; check for free space between ptrW and ptrR
	.wait_free_space:
	mov A,[ptrR]
	sub A,[ptrW]
	jnc .skip_corr
		add A,BUFFERSIZE*BUFFNUMBER
	.skip_corr:
	cmp A,1+1
	jc .wait_free_space
	jmp main_ReadData_loop

.LITERAL     ;-----     Big Endian  (   ,    "DBL") -------
track_table: DW track0, track1, track2, track3, track4, track5, track6, track7, track8, track9, track9, track9, track9, track9, track9, track9
.ENDLITERAL


;----------------------------    -    -----------------------------
n2:
	;toLCD_String 0,0,"noFile          "
	;    
	jmp main_loop
;--------------------------------   ------------------------------------
wait_finish:
	;    (   [ptrW]==[ptrR])
	mov A,[ptrW]
	cmp A,[ptrR]
	jnz wait_finish

	;   (   FLASH   "0"  "Synth.asm"  !)
	call synth_notes_off

	;toLCD_String 1,0,"Loop"

main_loop::	jmp main_loop
;------------------------------   main.asm -------------------------------

